package ejem07;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class animator extends Applet implements Runnable, ActionListener {

	Thread ani=null; 
	Panel cp;
	filmCanvas ic;
	TextField tf;
	Button bfirst,bprev,bplay,bnext,blast;

	public void init() { 
		setLayout(new BorderLayout());
		add("South",cp=new Panel());
		cp.setFont(new Font("TimesRoman",Font.PLAIN,9));
		cp.setLayout(new GridLayout(1,6));
		cp.add(tf=new TextField("",4));
		cp.add(bfirst=new Button("<<"));
		cp.add(bprev=new Button("<"));
		cp.add(bplay=new Button("anim"));
		cp.add(bnext=new Button(">"));
		cp.add(blast=new Button(">>"));
		add("Center",ic=new filmCanvas(this,tf));

		bfirst.addActionListener(this);
		bprev.addActionListener(this);
		bplay.addActionListener(this);
		bnext.addActionListener(this);
		blast.addActionListener(this);
	}

/* --------------------- Action Listener ------------------ */

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof Button) {
			if (e.getSource()==bfirst) {
				ic.showFrame(0);
			} else if (e.getSource()==bprev) {
				ic.showNextFrame(false);
			} else if (e.getSource()==bplay) {
				ic.animate();
			} else if (e.getSource()==bnext) {
				ic.showNextFrame(true);
			} else if (e.getSource()==blast) {
				ic.showFrame(100);
			}
		}
	}

	public void start()	{
		ani=new Thread(this); 
		ani.start();
	}

	public void stop() { 
		if (ani!=null) {
			ani.stop(); 
			ani=null;
		}	
	}

	public void run() { 
		ic.initialize(); 
		ani.stop(); 
	}

}


class filmCanvas extends Canvas {
	Applet A; 
	TextField Tf;
	Image offscr=null;
	Graphics osg=null;
	MediaTracker tracker=null;
	int N1=0,N2=100,n=N1;
	Image[] film=new Image[100];
	String[] name=new String[100];
	String[] number=new String[100];
	boolean[] exists=new boolean[100];

	long dT=100;
	int x0=-1, y0=-1, r=-1;
	boolean mark=false,ready=false,upwards=true;
	Color markColor=Color.yellow;

	filmCanvas(Applet a,TextField tf) { 
		A=a; 
		Tf=tf;
	}

	int intParam(String strparam,int default_int) { 
		int aux=default_int;
		try { 
			aux=Integer.parseInt(A.getParameter(strparam)); 
		} catch (NumberFormatException e) { 
			aux=default_int; 
		}
		return aux;
	}

	Color colorParam(String strparam,Color default_color) { 
		if (strparam.equalsIgnoreCase("null")) {
			return default_color;
		}
		String str=A.getParameter(strparam);
		if (str==null) {
			return default_color;
		}
		int color=0;
		try { 
			color=Integer.parseInt(str,16); 
		} catch (NumberFormatException e) {
			if (str.equalsIgnoreCase("black")) {     
				return Color.black;
			} else if (str.equalsIgnoreCase("blue")) {      
				return Color.blue;
			} else if (str.equalsIgnoreCase("cyan")) {      
				return Color.cyan;
			} else if (str.equalsIgnoreCase("darkGray")) {  
				return Color.darkGray;
			} else if (str.equalsIgnoreCase("gray")) {      
				return Color.gray;
			} else if (str.equalsIgnoreCase("green")) {     
				return Color.green;
			} else if (str.equalsIgnoreCase("lightGray")) { 
				return Color.lightGray;
			} else if (str.equalsIgnoreCase("magenta")) {   
				return Color.magenta;
			} else if (str.equalsIgnoreCase("orange")) {    
				return Color.orange;
			} else if (str.equalsIgnoreCase("pink")) {      
				return Color.pink;
			} else if (str.equalsIgnoreCase("red")) {       
				return Color.red;
			} else if (str.equalsIgnoreCase("white")) {     
				return Color.white; 
			} else if (str.equalsIgnoreCase("yellow")) {    
				return Color.yellow;
			}
			return default_color;
		}
		return new Color(color);
	}

	void initialize() { 
		N1=intParam("FIRST",N1);
		N2=intParam("LAST",N2);
		dT=(long)intParam("TIME_DELAY",(int)dT);
		x0=intParam("X0",-1);
		y0=intParam("Y0",-1);
		r =intParam("R",-1);
		markColor=colorParam("COLOR",markColor);
		if ((r>=0) && (x0>=0) && (y0>=0)) {
			mark=true; 
		} else {
			mark=false;
		}
		String ext=A.getParameter("IMAGE_EXT");
		if ((ext==null)||(ext.length()==0)) {
			ext=new String("jpg");
		}

		offscr=createImage(getSize().width,getSize().height);
		osg=offscr.getGraphics();
		osg.setColor(markColor);

		tracker=new MediaTracker(this);
		StringBuffer aux=null;
		boolean found=false;
		n=N1;
		int last=N1;
		while (n<=N2) {
			exists[n]=false;
			aux=new StringBuffer(Integer.toString(n));
			while (aux.length()<2) {
				aux.insert(0,"0");
			}
			number[n]=new String(aux);
			name[n]=new String(A.getParameter("NAME_BASE")+number[n]+"."+ext);
			film[n]=A.getImage(A.getDocumentBase(),name[n]);
			if (film[n]!=null) {
				tracker.addImage(film[n],n);
				Tf.setText(number[n]);
				try { 
					tracker.waitForID(n); 
				} catch(InterruptedException e) {
				}
				exists[n]=!tracker.isErrorID(n);
				if (exists[n]) { 
					if (!found) { 
						N1=n; 
					}
					found=true;
					showFrame(n);
					last=n;
				}
			}
			n++;
		}
		N2=last;
		upwards=true;
		showFrame(N1);
	}

	void animate() {
		Graphics g=getGraphics();
		n=N1;
		long T=0;
		while (n<=N2) {  
			if (exists[n]) {
				Tf.setText(number[n]);
				T=System.currentTimeMillis()+dT;
				showFrame(g);
				while (T>System.currentTimeMillis()) { 
				} 
			}
			n++;
		}
		n=N2;
	}

	void showNextFrame(boolean up) {
		upwards=up;
		if (upwards) { 
			n++; 
		} else { 
			n--; 
		}
		showFrame(getGraphics());
	}

	void showFrame(int k) {
		n=k; 
		showFrame(getGraphics());
	}

	void showFrame(Graphics g) {
		if (upwards) {
			while((n<N2)&&(!exists[n])) { 
				n++; 
			}
		} else {
			while((n>N1)&&(!exists[n])) { 
				n--; 
			}
		}
		if (n<N1) { 
			n=N1; 
		}
		if (n>N2) {
			n=N2;
		}
		Tf.setText(number[n]);
		osg.drawImage(film[n],0,0,this);
		if (mark) {
			osg.drawOval(x0-r,y0-r,r+r+1,r+r+1);
		}
		g.drawImage(offscr,0,0,this);
		ready=true;
	}

	public void paint(Graphics g) { 
		if (ready) {
			g.drawImage(offscr,0,0,this); 
		}
	}

	public void update(Graphics g) { 
		paint(g); 
	}

}