package ejem07;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class billar extends Applet implements Runnable, MouseListener,
	MouseMotionListener{

	static final int b=16;
	static final Color[] c ={ new Color(200,16,16), 
		new Color(240,240,240), 
		new Color(255,255,200) };
	static final Color verde0=new Color(24,160,96);
	static final Color verde1=new Color(20,144,80);
	static final Color verde2=new Color(16,128,64);

	private bola[] B,B0;
	private Image fondo,imagen;
	private AudioClip clok,pluk;
	private Thread thr=null;
	private Graphics g;
	private boolean apuntando=false;
	private int x0,y0,x1,y1,x2,y2;

	public void init() {
		B=new bola[3];
		for (int i=0;i<3;i++) { 
			B[i]=new bola(c[i]); 
		}
		clok=getAudioClip(getCodeBase(),"ejem07/au/clok.au"); 
		clok.play();
		pluk=getAudioClip(getCodeBase(),"ejem07/au/pluk.au"); 
		pluk.play();

		addMouseListener(this);
		addMouseMotionListener(this);
	}

	public void start()	{
		int w=getSize().width, h=getSize().height;
		fondo=createImage(w,h); 
		g=fondo.getGraphics();
		g.setColor(verde0); 
		g.fillRect(0,0,w,h);
		g.setColor(verde1); 
		g.fillRect(b,b,w-2*b,h-2*b);
		g.setColor(verde2);
		int L=b/2;
		int M=(w-2*b)/L,N=(h-2*b)/L;
		int x=b;
		for (int i=0;i<M;i++) { // dibujar cuadritos
			int y=b;
			for (int j=0;j<N;j++) {
				if ((i+j)%2==0) { 
					g.fillRect(x,y,L,L); 
				}
				y+=L;
			}
			x+=L;
		}
		g.setColor(Color.darkGray); 
		g.drawRect(b,b,w-2*b,h-2*b);
		imagen=createImage(w,h); 
		imagen.getGraphics().drawImage(fondo,0,0,this);
		bola.distribuirAlAzar(B,b,b,w-2*b,h-2*b);
		B0=bola.copy(B);
		bola.dibujar(B,fondo,imagen,this);
		if (thr==null) { 
			thr=new Thread(this); 
			thr.start(); 
		}
	}

	public void stop() {
		if (thr!=null) { 
			thr.stop(); 
			thr=null; 
		}
	}

	public void run() {
		int w=getSize().width, h=getSize().height;
		while (true) {
			try	{
				if (!bola.reposo(B)) {
					bola.guardarPosiciones(B);
					bola.avanzar(B);
					bola.amortiguar(B);
					if (bola.rebotes(B,b,b,w-b,h-b)) { 
						pluk.play(); 
					}
					if (bola.choques(B)) { 
						clok.play(); 
					}
					bola.dibujar(B,fondo,imagen,this);
					thr.sleep(5);
				} else { 
					thr.sleep(50); 
				}
			} catch (InterruptedException ie) { 
				return; 
			}
		}
	}

	public void paint(Graphics g) {
		if (imagen!=null) { 
			g.drawImage(imagen,0,0,this); 
		}
	}

	public void update(Graphics g) { 
		paint(g); 
	}


/* --------------------- Mouse Listener ------------------ */

	public void mouseClicked(MouseEvent e) {}

	public void mousePressed(MouseEvent e) {
		int x=e.getX(), y=e.getY();
		if (e.getModifiers()==MouseEvent.BUTTON3_MASK) { // botn derecho
			B=B0; 
			imagen.getGraphics().drawImage(fondo,0,0,this);
			bola.dibujar(B,fondo,imagen,this);
			getGraphics().drawImage(imagen,0,0,this);
		} else {
			for (int i=0;i<3;i++) { 
				B[i].fijarVelocidad(new R2(0,0)); 
			}
			for (int i=0;i<3;i++) { 
				if (B[i].dentro(new R2(x,y))) {
					R2 centro=B[i].centro();
					x0=(int)Math.round(centro.x);
					y0=(int)Math.round(centro.y);
					g=getGraphics();
					g.setXORMode(Color.black);
					x1=x; 
					y1=y;
					g.setColor(Color.white); 
					g.drawLine(x0,y0,x1,y1);
					x2=x0+(x0-x1)*3; 
					y2=y0+(y0-y1)*3;
					g.setColor(Color.yellow); 
					g.drawLine(x0,y0,x2,y2);
					apuntando=true;
					break;
				}
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		int x=e.getX(), y=e.getY();
		if (apuntando) {
			g.setColor(Color.white);  g.drawLine(x0,y0,x1,y1);
			g.setColor(Color.yellow); g.drawLine(x0,y0,x2,y2);
			g.setPaintMode();
			for (int i=0;i<3;i++) {
				B0=bola.copy(B);
				if ( (B[i].dentro(new R2(x0,y0)))&&(!B[i].dentro(new R2(x,y))) ) {
					R2 v=new R2(x0-x,y0-y); 
					v.mul(0.02);
					B[i].fijarVelocidad(v);
					break;
				}
			}
		}
		apuntando=false;
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

/* --------------------- Mouse Motion Listener ------------------ */

	public void mouseMoved(MouseEvent e) {}

	public void mouseDragged(MouseEvent e) {
		int x=e.getX(), y=e.getY();
		if (apuntando) {
			g.setColor(Color.white); 
			g.drawLine(x0,y0,x1,y1);
			x1=x; 
			y1=y;
			g.drawLine(x0,y0,x1,y1);
			g.setColor(Color.yellow);
			g.drawLine(x0,y0,x2,y2);
			x2=x0+(x0-x1)*3; 
			y2=y0+(y0-y1)*3; 
			g.drawLine(x0,y0,x2,y2);
		}
	}
}