package ejem07;

import java.awt.*;

public class bola {

	public static final int r=7, d=r*2;
	public static final double R=r, D=d, D2=D*D;
	private static final double aM=0.997,am=0.993,aa=6,vparo=0.05;
	private R2 p,pa,v,t,n;
	private Color c;

	public bola(Color c) {
		p=new R2(0,0); 
		v=new R2(0,0); 
		pa=p.copy(); 
		fijarVelocidad(v);
		this.c=c; 
	}

	public bola copy() {
		bola b=new bola(c);
		b.fijarPosicin(p); 
		b.fijarVelocidad(v); 
		b.pa.x=p.x; 
		b.pa.y=p.y;
		return b;
	}

	public R2 centro() { 
		return new R2(p.x+r,p.y+r); 
	}

	public void fijarPosicin(R2 p) { 
		this.p=p.copy(); 
	}

	public void fijarVelocidad(R2 v) { 
		this.v=v.copy(); 
		t=v.copy(); 
		t.normalize();
		n=t.copy(); 
		n.rotL90();
	}

	public void guardarPosicin() { 
		pa.x=p.x; 
		pa.y=p.y; 
	}

	public double distancia(bola b) { 
		return p.dist(b.p); 
	}

	public boolean dentro(R2 q) {
		return centro().dist(q)<=R; 
	}

	/* mtodos para el movimiento */
	public void avanzar() { 
		p.add(v); 
	}
	
	public void amortiguar() { 
		double aux=aa*v.norm();
		v.mul((am+aM*aux)/(1+aux)); 
		if (Math.abs(v.norm())<vparo) { 
			v.x=0; 
			v.y=0; 
		}
	}

	public boolean rebote(double xi,double yi,double xf,double yf) { // en orillas
		boolean choque=false;
		if (p.x<xi)   { 
			p.x=xi+(xi-p.x);     
			v.x=-v.x; 
			choque=true; 
		}
		if (p.x>xf-d) { 
			p.x=xf-d-(p.x-xf+d); 
			v.x=-v.x; 
			choque=true; 
		}
		if (p.y<yi)   { 
			p.y=yi+(yi-p.y);     
			v.y=-v.y; 
			choque=true; 
		}
		if (p.y>yf-d) { 
			p.y=yf-d-(p.y-yf+d); 
			v.y=-v.y; 
			choque=true; 
		}
		fijarVelocidad(v);
		return choque;
	}

	public boolean choque(bola b) { // (con otra bola)
		R2 s=b.p.copy(); 
		s.sub(p);
		double h=Math.abs(s.dot(n));
		if (h<D) { 
			double w=Math.sqrt(D2-h*h);
			R2 sa=b.p.copy(); 
			sa.sub(pa);
			if ((sa.dot(t)>=w)&&(s.dot(t)<w)) {
			/* --- tiempo transcurrido despus del choque --- */
				double dt=(w-s.dot(t))/v.norm();
				/* --- regresar "this" al punto de contacto --- */
				R2 aux=v.copy();  aux.mul(dt);  p.sub(aux);
				/* --- normal (en) y tangente (et) a la superficie de contacto --- */
				R2 va=v.copy(), bva=b.v.copy();
				R2 en=p.copy(); en.sub(b.p); en.normalize();
				R2 et=en.copy(); et.rotL90();
				/* --- velocidad de "this", adoptando la velocidad normal de "b" --- */
				R2 vn=en.copy(); vn.mul(en.dot(bva));
				R2 vt=et.copy(); vt.mul(et.dot(va));
				v=vn.copy(); v.add(vt);
				fijarVelocidad(v);
				/* --- velocidad de "b", adoptando la velocidad normal de "this" --- */
				R2 bvn=en.copy(); bvn.mul(en.dot(va));
				R2 bvt=et.copy(); bvt.mul(et.dot(bva));
				b.v=bvn.copy(); b.v.add(bvt);
				b.fijarVelocidad(b.v);
				/* --- avance posterior al choque de "this" --- */
				aux=v.copy();
				aux.mul(dt);
				p.add(aux);
				/* --- avance posterior al choque de "b" --- */
				aux=b.v.copy();
				aux.mul(dt);
				b.p.add(aux);
				return true;
			}
		}
		return false; 
	} 

/* --- Mtodos estticos para "arrays" de bolas --- */
	public static void distribuirAlAzar(bola[] B,int x0,int y0,int dw,int dh) {
		do {
			for (int i=0;i<3;i++) {
				B[i].fijarPosicin(new R2(x0+(dw-bola.d)*Math.random(),
					  y0+(dh-bola.d)*Math.random()));
			}
		} while ( B[0].dentro(B[1].centro()) || 
			B[1].dentro(B[2].centro()) || 
			B[2].dentro(B[0].centro()) );
	}

	public static bola[] copy(bola[] B) {
		bola[] b= new bola[B.length];
		for (int i=0;i<B.length;i++) { 
			b[i]=B[i].copy(); 
		}
		return b;
	}

	public static void guardarPosiciones(bola[] B) {
		for (int i=0;i<B.length;i++) { 
			B[i].guardarPosicin(); 
		}
	}

	public static void avanzar(bola[] B) {
		for (int i=0;i<B.length;i++) { 
			B[i].avanzar(); 
		}
	}

	public static void amortiguar(bola[] B)	{
		for (int i=0;i<B.length;i++) { 
			B[i].amortiguar(); 
		}
	}

	public static boolean reposo(bola[] B) {
		for (int i=0;i<B.length;i++) {
			if (B[i].v.norm()!=0) { 
				return false; 
			}
		}
		return true;
	}

	public static boolean rebotes(bola[] B,double xi,double yi,
			double xf,double yf) { // en orillas
		boolean hayRebote=false;
		for (int i=0;i<B.length;i++) { 
			if (B[i].rebote(xi,yi,xf,yf)) { 
				hayRebote=true; 
			}
		}
		return hayRebote;
	}

		public static boolean choques(bola[] B)	{ // entre bolas
		boolean hayChoque=false;
		for (int i=0;i<B.length;i++) { 
			for (int j=0; j<B.length; j++) {
				if ((j!=i)&&(B[i].choque(B[j]))) { 
					hayChoque =true; 
				}
			}
		}
		return hayChoque;
	}

	public static void dibujar(bola[] B,
				 Image fondo, Image imagen,
				 Component cmp)	{
		/*  mtodo de "doble imagen" para animacin avanzada */
		int[] xa=new int[B.length];
		int[] ya=new int[B.length];
		int[] x=new int[B.length];
		int[] y=new int[B.length];
		for (int i=0;i<B.length;i++) {
			xa[i]=(int)Math.round(B[i].pa.x);
			ya[i]=(int)Math.round(B[i].pa.y);
			x[i]=(int)Math.round(B[i].p.x);
			y[i]=(int)Math.round(B[i].p.y);
		}
		/* copiar trozos del fondo a imagen 
		para borrar las bolas anteriorres */
		Graphics g;
		for (int i=0;i<B.length;i++) {
			g=imagen.getGraphics();
			g.clipRect(xa[i],ya[i],B[i].d+1,B[i].d+1);
			g.drawImage(fondo,0,0,cmp);
		}
		/* dibujar las nuevas bolas en imagen */
		g=imagen.getGraphics();
		for (int i=0;i<B.length;i++) {
			g.setColor(B[i].c);  
			g.fillOval(x[i],y[i],B[i].d,B[i].d);
		}
		/* copiar todos trozos modificados de imagen a cmp */
		for (int i=0;i<B.length;i++) {
			g=cmp.getGraphics();
			g.clipRect(xa[i],ya[i],B[i].d+1,B[i].d+1);
			g.drawImage(imagen,0,0,cmp);
			g=cmp.getGraphics();
			g.clipRect(x[i],y[i],B[i].d+1,B[i].d+1);
			g.drawImage(imagen,0,0,cmp);
		}
	}

}