package ejem07;

import java.awt.*;
import java.awt.image.*;

public class fondosCirculares {

	public static Image[] crear(Component cmp,Color BGcolor) {
		int imgw=cmp.getSize().width, imgh=cmp.getSize().height;
		/* ------- dibujo del fondo en una matriz de bytes ------ */
		byte[] ib=new byte[imgw*imgh];
		int wl=16;
		int P=32*wl;
		byte[] fb=new byte[P];
		int ofs=0;
		for (int i=0;i<P;i++) { 
			fb[ofs++]=(byte)((i/wl)%32); 
		}
		ofs=0;
		long ii=0,jj=0,w2=imgw*imgw,h2=imgh*imgh;
		int ti=0;
		for (int j=0;j<imgh;j++) {
			for (int i=0;i<imgw;i++) { 
				ii=i-imgw/2; jj=j-imgh/2; 
				ti=(int)((ii*ii+jj*jj)/16);
				ib[ofs++]=fb[ti%P];
			}
		}
		/* ----- Matrices de bytes para los colores mviles --- */
		byte[] Red=new byte[32];
		byte[] Green=new byte[32];
		byte[] Blue=new byte[32];
		for (int i=0;i<32;i++) { 
			Blue[i] = (byte)((i*BGcolor.getBlue())/16); 
			Green[i]= (byte)((i*BGcolor.getGreen())/16); 
			Red[i]  = (byte)((i*BGcolor.getRed())/16); 
		}
		for (int i=16;i<32;i++) { 
			Blue[i]=Blue[31-i]; 
			Green[i]=Green[31-i]; 
			Red[i]=Red[31-i]; 
		}
		/* ------- creacin de las imgenes del fondo -------- */
		IndexColorModel ixcm;
		MemoryImageSource mis;
		Image[] fondo=new Image[32];
		for (int k=0;k<fondo.length;k++) { 
		/* -- creacin del "buffer" para la imagen del fondo -- */
			shiftArray(false,32,Red);
			shiftArray(false,32,Green);
			shiftArray(false,32,Blue);
			ixcm=new IndexColorModel(8,32,Red,Green,Blue);
			mis=new MemoryImageSource(imgw,imgh,ixcm,ib,0,imgw);
			Image auxima=cmp.createImage(mis);
			fondo[k]=cmp.createImage(imgw,imgh);
			fondo[k].getGraphics().drawImage(auxima,0,0,cmp);
		}
		return fondo;
	}

	private static void shiftArray(boolean left,int sz,byte[] b) { 
		byte aux=0;
		if (left) { 
			aux=b[0]; 
			System.arraycopy(b,1,b,0,sz-1); 
			b[sz-1]=b[0]; 
		} else { 
			aux=b[sz-1]; 
			System.arraycopy(b,0,b,1,sz-1); 
			b[0]=b[sz-1]; 
		}
	}

}